//
//  LGLCalenderViewController.m
//  LGLProgress
//
//  Created by 李国良 on 2016/10/11.
//  Copyright © 2016年 李国良. All rights reserved.
//  https://github.com/liguoliangiOS/LGLCalender.git

#import "LGLCalenderViewController.h"
#import "LGLCalenderCell.h"
#import "LGLHeaderView.h"
#import "LGLCalenderModel.h"
#import "LGLCalenderSubModel.h"
#import "LGLCalendarDate.h"
#import "LGLWeekView.h"
//#import "NetWork.h"
#import "XLPlainFlowLayout.h"
#import "CGXPickerView.h"
#import "Tool.h"
#define WIDTH [UIScreen mainScreen].bounds.size.width
#define HEIGHT [UIScreen mainScreen].bounds.size.height
#define LGLColor(r, g, b) [UIColor colorWithRed:(r)/255.0 green:(g)/255.0 blue:(b)/255.0 alpha:1.0]

@interface LGLCalenderViewController ()<UICollectionViewDelegate, UICollectionViewDataSource>
{
    NSInteger _year;
    NSInteger _month;
    NSInteger _day;
    UILabel *lab;
    UILabel  *houstLb;
    NetWork  *network ;
}
@property (nonatomic, strong) UICollectionView * collectionView;
@property (nonatomic, strong) NSMutableArray * dataSource;
@property (nonatomic, strong) NSMutableDictionary *cellDic; // 用来存放Cell的唯一标示符
@property (nonatomic,strong) NSMutableArray<NSIndexPath *> *fristArray;
@property (nonatomic,strong) NSMutableArray *endArray;
@property (nonatomic,strong) NSMutableArray  *houseNameArr;
@property (nonatomic,strong) NSMutableArray  *houseTypeIdArr;
@end

@implementation LGLCalenderViewController

- (void)viewDidLoad {
    
    [super viewDidLoad];
    self.houseNameArr = [NSMutableArray array];
    self.houseTypeIdArr = [NSMutableArray array];
    network  =[[NetWork alloc]init];
    self.view.backgroundColor = [UIColor whiteColor];
    self.fristArray = [NSMutableArray array];
    [self initOtherData];
    [self addHeaderWeekView];
    [self jumpHouse];
    [self createCalendarView];
    
}


- (void)addHeaderWeekView {
    houstLb = [[UILabel alloc]initWithFrame:CGRectMake(10, 10, viewSize.width, 20)];
    houstLb.textColor  =titleClo;
   
    [self.view addSubview:houstLb];
    UIButton  *houseBtn = [[UIButton alloc]initWithFrame:CGRectMake(0, 0, viewSize.width, 40)];
    houseBtn.backgroundColor = [UIColor clearColor];
    [houseBtn addTarget:self action:@selector(jumpHouse) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:houseBtn];
      NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:@"20",@"pageSize",@"1",@"pageNumber", nil];
    [network netWorkWithPost:API_HouseList params:dic viewController:self success:^(id responseObject) {
        NSArray  *arr  =[responseObject objectForKey:@"resultContent"];
        for (NSDictionary  *dic in arr) {
            NSString  *roomTypeId = [NSString stringWithFormat:@"%@",[dic  objectForKey:@"roomTypeId"] ];
            NSString  *name = [NSString stringWithFormat:@"%@",[dic  objectForKey:@"name"]];
            [self.houseNameArr addObject:name];
            [self.houseTypeIdArr addObject:roomTypeId];
        }
         houstLb.text = self.houseNameArr.firstObject;
        NSString  *roomId = self.houseTypeIdArr.firstObject;
        NSString  *currem = [Tool getCurrentTimesandFormat:@"yyyy-MM-dd  HH:mm:ss"];
        NSString  *currTime =[NSString stringWithFormat:@"%ld", (long)[Tool timeSwitchTimestamp:currem andFormatter:@"yyyy-MM-dd  HH:mm:ss"]];
        NSString *year  =[NSString stringWithFormat:@"%@",[Tool currTimeNextNumDays:@"180" andFormat:@"yyyy-MM-dd  HH:mm:ss"]];
        NSLog(@"year  %@",year);
        NSString  *endTime = [NSString stringWithFormat:@"%ld",(long)[Tool timeSwitchTimestamp:year andFormatter:@"yyyy-MM-dd  HH:mm:ss"]];
        [network netWorkWithPost:API_finfHousePrice params:[NSDictionary dictionaryWithObjectsAndKeys:currTime,@"startDate",endTime,@"endDate",roomId,@"roomTypeId", nil] viewController:self success:^(id responseObject) {
            [self calculateTime:[responseObject objectForKey:@"resultContent"]];
             NSLog(@"%@  ========time",responseObject);
        } failed:nil];
        
    } failed:nil];

    LGLWeekView * week = [[LGLWeekView alloc] initWithFrame:CGRectMake(0, 40, WIDTH, 40)];
    [self.view addSubview:week];
}
-(void)jumpHouse{
    NSString  *currem = [Tool getCurrentTimesandFormat:@"yyyy-MM-dd  HH:mm:ss"];
    NSString  *currTime =[NSString stringWithFormat:@"%ld", (long)[Tool timeSwitchTimestamp:currem andFormatter:@"yyyy-MM-dd  HH:mm:ss"]];
    NSString *year  =[NSString stringWithFormat:@"%@",[Tool currTimeNextNumDays:@"180" andFormat:@"yyyy-MM-dd  HH:mm:ss"]];
    NSLog(@"year  %@",year);
    NSString  *endTime = [NSString stringWithFormat:@"%ld",(long)[Tool timeSwitchTimestamp:year andFormatter:@"yyyy-MM-dd  HH:mm:ss"]];
 
    [CGXPickerView showStringPickerWithTitle:@"选择" DataSource:self.houseNameArr DefaultSelValue:self.houseNameArr.firstObject IsAutoSelect:NO Manager:nil ResultBlock:^(id selectValue, id selectRow) {
        NSLog(@"%@",selectValue);
        houstLb.text = selectValue;
      NSInteger index = [self.houseNameArr indexOfObject:selectValue];
        NSString  *roomId = self.houseTypeIdArr[index];
        [network netWorkWithPost:API_finfHousePrice params:[NSDictionary dictionaryWithObjectsAndKeys:currTime,@"startDate",endTime,@"endDate",roomId,@"roomTypeId", nil] viewController:self success:^(id responseObject) {
            NSLog(@"%@  ========time",responseObject);
            [self calculateTime:[responseObject objectForKey:@"resultContent"]];
        } failed:nil];
        
        
    }];
}

-(void)calculateTime:(NSDictionary  *)dic{
    NSString  *price = [dic  objectForKey:@"price"];
    NSString  *weekendPrice = [dic  objectForKey:@"weekendPrice"];
    NSMutableArray  *dateArr  = [NSMutableArray array];
    NSMutableArray  *priceArr = [NSMutableArray array];
    NSArray  *specialAr  =[NSArray arrayWithArray:[dic  objectForKey:@"specialPrices"]];
    for (int j = 0; j<specialAr.count; j++) {
        NSDictionary *dic = specialAr[j];
         NSString  *speciaTime = [Tool timeChange:[dic  objectForKey:@"date"]  andFormat:@"yyyy-MM-dd"];
        [dateArr addObject:speciaTime];
        [priceArr addObject:[dic objectForKey:@"price"]];
    }
    NSMutableArray  *priceArray = [NSMutableArray array];
//
    NSLog(@"dateArr  ==%@",dateArr);
    for (int i=0; i<180; i++) {
//        for (int j = 0; j<specialAr.count; j++) {
//            NSDictionary *dic = specialAr[j];
        NSLog(@"naexTime %@",[Tool currTimeNextNumDays:[NSString stringWithFormat:@"%d",i] andFormat:@"yyyy-MM-dd"]);
      if ([dateArr containsObject:[Tool currTimeNextNumDays:[NSString stringWithFormat:@"%d",i] andFormat:@"yyyy-MM-dd"]]) {
          NSInteger  ind = [dateArr indexOfObject:[Tool currTimeNextNumDays:[NSString stringWithFormat:@"%d",i] andFormat:@"yyyy-MM-dd"]];
           [priceArray addObject:priceArr[ind] ];
//                return;
      }else{
          
          NSString  *weekDay = [Tool weekDayNextNumDays:i];
          if ([weekDay isEqualToString:@"周日"]) {
              [priceArray addObject:weekendPrice];
              
          }else if([weekDay isEqualToString:@"周六"]){
              
              [priceArray addObject:weekendPrice];
          }else{
              
              [priceArray addObject:price];
          }
          
      }

    }
    [self getData:priceArray];
    NSLog(@"priceArray   %@",priceArray);
}


- (void)initOtherData {
    self.title = @"价格管理";
    
    //获取当前的年月日
     _year = [LGLCalendarDate year:[NSDate date]];
     _month = [LGLCalendarDate month:[NSDate date]];
     _day = [LGLCalendarDate day:[NSDate date]];
}


-(void)createCalendarView
{
    XLPlainFlowLayout * layout = [[XLPlainFlowLayout alloc] init];
    layout.naviHeight = 0.0;
    //布局
    //UICollectionViewFlowLayout *layout=[[UICollectionViewFlowLayout alloc] init];
    //设置item的宽高
    layout.itemSize=CGSizeMake(WIDTH / 7, WIDTH / 7);
    //设置滑动方向
    layout.scrollDirection=UICollectionViewScrollDirectionVertical;
    //设置行间距
    layout.minimumLineSpacing=0.0f;
    //每列的最小间距
    layout.minimumInteritemSpacing = 0.0f;
    //四周边距
    layout.sectionInset=UIEdgeInsetsMake(0, 0, 0, 0);
    self.collectionView=[[UICollectionView alloc] initWithFrame:CGRectMake(0, 80, WIDTH, HEIGHT - 140-NAVIGATION_BAR_HEIGHT-HOME_INDICATOR_HEIGHT) collectionViewLayout:layout];
    self.collectionView.backgroundColor=[UIColor whiteColor];
    self.collectionView.delegate=self;
    self.collectionView.dataSource=self;
    self.collectionView.showsVerticalScrollIndicator=NO;
    [self.view addSubview:self.collectionView];
   // [self.collectionView registerClass:[LGLCalenderCell class] forCellWithReuseIdentifier:@"calender"];
    [self.collectionView registerClass:[LGLHeaderView class] forSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:@"calenderHeaderView"];
 UILabel   *lab1 = [[UILabel alloc]initWithFrame:CGRectMake(0, HEIGHT-NAVIGATION_BAR_HEIGHT-HOME_INDICATOR_HEIGHT - 60, viewSize.width, 15)];
    lab1.text = @"提示: 当前展示价格为卖价";
    lab1.textColor =ThemeColor;
    lab1.backgroundColor = Color(251, 240, 230, 1);
    lab1.font = [UIFont systemFontOfSize:11];
    [self.view addSubview:lab1];
    
    lab = [[UILabel alloc]initWithFrame:CGRectMake(0, HEIGHT-NAVIGATION_BAR_HEIGHT-HOME_INDICATOR_HEIGHT - 30, 80, 10)];
    lab.text = @"已选 0天";
    [self.view addSubview:lab];
    
    UIButton *deleBtn = [[UIButton alloc]initWithFrame:CGRectMake(90, HEIGHT-HOME_INDICATOR_HEIGHT -NAVIGATION_BAR_HEIGHT- 35, 40, 20)];
    [deleBtn setTitle:@"清空" forState:UIControlStateNormal];
    [deleBtn setTitleColor:ThemeColor forState:UIControlStateNormal];
    [deleBtn addTarget:self action:@selector(delde) forControlEvents:UIControlEventTouchUpInside];
    [deleBtn setTitleColor:[UIColor orangeColor] forState:UIControlStateNormal];
    [self.view addSubview:deleBtn];
//    
//    UIButton *dele2Btn = [[UIButton alloc]initWithFrame:CGRectMake(viewSize.width-180, HEIGHT - 40-HOME_INDICATOR_HEIGHT-NAVIGATION_BAR_HEIGHT, 80, 30)];
//    [dele2Btn setTitle:@"删除房价" forState:UIControlStateNormal];
//    dele2Btn.layer.borderWidth  =1;
//    dele2Btn.layer.borderColor = bgroundColor.CGColor;
//    dele2Btn.layer.cornerRadius = 5;
//     dele2Btn.backgroundColor = [UIColor whiteColor];
//    [dele2Btn addTarget:self action:@selector(delde2) forControlEvents:UIControlEventTouchUpInside];
//    [dele2Btn setTitleColor:ThemeColor forState:UIControlStateNormal];
//    [self.view addSubview:dele2Btn];
    
    
    UIButton *changBtn = [[UIButton alloc]initWithFrame:CGRectMake(viewSize.width-90, HEIGHT -HOME_INDICATOR_HEIGHT- 40-NAVIGATION_BAR_HEIGHT, 80, 30)];
    [changBtn setTitle:@"修改房价" forState:UIControlStateNormal];
       [changBtn addTarget:self action:@selector(change) forControlEvents:UIControlEventTouchUpInside];
    changBtn.backgroundColor = ThemeColor;
    changBtn.layer.cornerRadius = 5;
    [changBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [self.view addSubview:changBtn];
    
    
}

- (void)getData:(NSArray *)dateArr{
    
    [LGLCalenderModel getCalenderDataWithDate:[NSDate date] priceArr:dateArr block:^(NSMutableArray *result) {
        [self.dataSource removeAllObjects];
        [self.dataSource addObjectsFromArray:result];
        [self.collectionView reloadData];
    }];
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView {
    return self.dataSource.count;
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    LGLCalenderModel * model = self.dataSource[section];
    return model.details.count + model.firstday;
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
   
    // 每次先从字典中根据IndexPath取出唯一标识符
    NSString *identifier = [_cellDic objectForKey:[NSString stringWithFormat:@"%@", indexPath]];
    // 如果取出的唯一标示符不存在，则初始化唯一标示符，并将其存入字典中，对应唯一标示符注册Cell
    if (identifier == nil) {
        identifier = [NSString stringWithFormat:@"LGLCalenderCell%@", [NSString stringWithFormat:@"%@", indexPath]];
        [_cellDic setValue:identifier forKey:[NSString stringWithFormat:@"%@", indexPath]];
        // 注册Cell
        [self.collectionView registerClass:[LGLCalenderCell class]  forCellWithReuseIdentifier:identifier];
    }
    LGLCalenderCell * cell = [collectionView dequeueReusableCellWithReuseIdentifier:identifier forIndexPath:indexPath];
    if (self.dataSource.count) {
         LGLCalenderModel * model = self.dataSource[indexPath.section];
        if (indexPath.item >= model.firstday) {
            NSInteger index = indexPath.item - model.firstday;
            LGLCalenderSubModel * subModel = model.details[index];
            cell.dateL.text = [NSString stringWithFormat:@"%ld",(long)subModel.day];
            cell.priceL.text = [NSString stringWithFormat:@"￥%@", subModel.price];
            
            cell.backgroundColor = [UIColor whiteColor];
            cell.priceL.textColor = ThemeColor;
            if ((model.year == _year) && (model.month == _month) && (subModel.day == _day))  {
                cell.dateL.text = @"今天";
                cell.priceL.text = [NSString stringWithFormat:@"￥%@", subModel.price];
            }
            
            if ((model.year == _year) && (model.month == _month) && (subModel.day < _day)) {
//                cell.backgroundColor = LGLColor(239, 239, 239);
                cell.backgroundColor = [UIColor whiteColor];
                cell.dateL.textColor = [UIColor lightGrayColor];
                cell.priceL.textColor = LGLColor(239, 239, 239);//[UIColor lightGrayColor];
//                cell.priceL.textColor = [UIColor lightGrayColor];
                cell.userInteractionEnabled = NO;
            }
        } else {
            cell.userInteractionEnabled = NO;
        
        }
    }
    return cell;
}

-(UICollectionReusableView *)collectionView:(UICollectionView *)collectionView viewForSupplementaryElementOfKind:(NSString *)kind atIndexPath:(NSIndexPath *)indexPath
{
    LGLHeaderView * headerView = [collectionView dequeueReusableSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:@"calenderHeaderView" forIndexPath:indexPath];
    LGLCalenderModel * model = self.dataSource[indexPath.section];
    headerView.dateL.text = [NSString stringWithFormat:@"%ld年%ld月",(long)model.year, (long)model.month];
    return headerView;
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout referenceSizeForHeaderInSection:(NSInteger)section
{
    return CGSizeMake(WIDTH, 40);
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    LGLCalenderCell  *cell  =(LGLCalenderCell *)[collectionView cellForItemAtIndexPath:indexPath];
    cell.priceL.textColor = [UIColor whiteColor];
    cell.backgroundColor = ThemeColor;
    LGLCalenderModel * model = self.dataSource[indexPath.section];
    NSInteger index = indexPath.row - model.firstday;
    LGLCalenderSubModel * subModel = model.details[index];
    NSMutableDictionary * dic = [NSMutableDictionary dictionary];
    [dic setValue: [NSString stringWithFormat:@"%ld", (long)model.year] forKey:@"year"];
    [dic setValue: [NSString stringWithFormat:@"%ld", (long)model.month] forKey:@"month"];
    [dic setValue: [NSString stringWithFormat:@"%ld", (long)subModel.day] forKey:@"day"];
    [dic setValue: [NSString stringWithFormat:@"%@",  subModel.price] forKey:@"price"];
    [self.fristArray addObject:indexPath];
    lab.text = [NSString stringWithFormat:@"已选 %lu",(unsigned long)self.fristArray.count];
//    self.block(dic);
    
//    [self.navigationController popViewControllerAnimated:YES];
}
-(void)delde{
    lab.text = @"已选 0";
   [self.collectionView reloadData];
    [self.fristArray removeAllObjects];
    
}
-(void)delde2{
    [self changprice:@"0"];
}
-(void)change{
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"提示" message:@"" preferredStyle:UIAlertControllerStyleAlert];
    //以下方法就可以实现在提示框中输入文本；
    //在AlertView中添加一个输入框
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        
        textField.placeholder = @"请输入修改后的价格";
    }];
    
    //添加一个确定按钮 并获取AlertView中的第一个输入框 将其文本赋值给BUTTON的title
    [alertController addAction:[UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        
        
        UITextField *envirnmentNameTextField = alertController.textFields.firstObject;
        
       [self changprice:envirnmentNameTextField.text];
        
    }]];
    
    //添加一个取消按钮
    [alertController addAction:[UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleDefault handler:nil]];
    
    //present出AlertView
    [self presentViewController:alertController animated:true completion:nil];

    
    
    
  
    
    
    
}
-(void)changprice:(NSString *)price{
    NSLog(@"%@",self.fristArray);
    NSMutableArray  *Arr = [NSMutableArray array];
    NSMutableArray  *priceArr = [NSMutableArray array];
    if (self.fristArray) {
    for (NSIndexPath *indexPath in self.fristArray) {
        LGLCalenderModel * model = self.dataSource[indexPath.section];
        NSInteger index = indexPath.row - model.firstday;
        LGLCalenderSubModel * subModel = model.details[index];
        LGLCalenderSubModel  *lglsubMode = [LGLCalenderSubModel new];
        lglsubMode.price =price;
        lglsubMode.day = subModel.day;
        NSString  *times  = [NSString stringWithFormat:@"%ld-%ld-%ld 00:00:00",(long)model.year,(long)model.month,(long)subModel.day];
               NSLog(@"%@   ===selcetTime ",times);
        NSString  *selcetTime = [NSString stringWithFormat:@"%ld",(long)[Tool timeSwitchTimestamp:times andFormatter:@"yyyy-MM-dd HH:mm:ss" ]];
        [Arr addObject:selcetTime];
        [priceArr addObject:price];
        [model.details replaceObjectAtIndex:index withObject:lglsubMode];
        LGLCalenderModel  *lglModel =[LGLCalenderModel new];
        lglModel.details = model.details;
        lglModel.year = model.year;
        lglModel.month = model.month;
        lglModel.firstday = model.firstday;
        [self.dataSource replaceObjectAtIndex:indexPath.section withObject:lglModel];
    }
        NSInteger ind = [self.houseNameArr indexOfObject:houstLb.text];
        NSString   *houseID  = self.houseTypeIdArr[ind];
        NSString  *date = [Arr  componentsJoinedByString:@","];
        NSString  *prices = [priceArr componentsJoinedByString:@","];
        [network  netWorkWithPost:API_changHousePrice params:[NSDictionary dictionaryWithObjectsAndKeys:houseID,@"roomTypeId",prices,@"prices",date,@"dates", nil] viewController:self success:^(id responseObject) {
            [NetWork  showHint:@"修改成功"];
            
        } failed:nil];
    [self.collectionView reloadData];
      [self.fristArray removeAllObjects];
    }else{
        [NetWork showHint:@"请选中"];
    }
    
    
}

- (void)seleDateWithBlock:(SelectDateBalock)block {
    self.block = block;
}

- (NSMutableArray *)dataSource {
    if (!_dataSource) {
        _dataSource = [NSMutableArray array];
    }
    return _dataSource;
}

- (NSMutableDictionary *)cellDic {
    if (!_cellDic) {
        _cellDic = [NSMutableDictionary dictionary];
    }
    return _cellDic;
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
