//
//  Tool.m
//  趣睡
//
//  Created by Yutao on 2018/5/31.
//  Copyright © 2018年 Yutao. All rights reserved.
//

#import "Tool.h"
//yyyy-MM-dd  HH:mm:ss
@implementation Tool
+(CAShapeLayer *)huayuanjiao:(CGRect )rect{
    UIBezierPath *maskPath = [UIBezierPath bezierPathWithRoundedRect:rect byRoundingCorners:UIRectCornerTopLeft |  UIRectCornerBottomLeft |   UIRectCornerBottomLeft |  UIRectCornerBottomRight cornerRadii:rect.size];
    CAShapeLayer *maskLayer = [[CAShapeLayer alloc]init];
    //设置大小
    maskLayer.frame = rect;
    //设置图形样子
    maskLayer.path = maskPath.CGPath;
    return maskLayer;
    
}

+(CGSize)sizeWithText:(NSString *)text andMaxSize:(CGSize)maxSize andFont:(UIFont *)font{
    
    NSDictionary *attr = @{NSFontAttributeName:font};
    return [text boundingRectWithSize:maxSize options:NSStringDrawingUsesLineFragmentOrigin attributes:attr context:nil].size;
    
}

+(NSString*)getCurrentTimesandFormat:(NSString *)Format {
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    
    // ----------设置你想要的格式,hh与HH的区别:分别表示12小时制,24小时制
    
    [formatter setDateFormat:Format];
    
    //现在时间,你可以输出来看下是什么格式
    
    NSDate *datenow = [NSDate date];
    
    //----------将nsdate按formatter格式转成nsstring
    
    NSString *currentTimeString = [formatter stringFromDate:datenow];
    
    NSLog(@"currentTimeString =  %@",currentTimeString);
    
    return currentTimeString;
    
}

+(NSString*)getCurrentNextTimesandFormat:(NSString *)Format {
    NSString *currtime= [Tool getCurrentTimesandFormat:Format] ;
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init]; [dateFormatter setDateFormat:Format];
    NSDate *destDate= [dateFormatter dateFromString:currtime];
    
    NSCalendar *gregorian = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *components = [gregorian components:NSCalendarUnitWeekday | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay fromDate:destDate];
    [components setDay:([components day]+1)];
    NSDate *beginningOfWeek = [gregorian dateFromComponents:components];
    NSDateFormatter *dateday = [[NSDateFormatter alloc] init];
    [dateday setDateFormat:Format];
    return [dateday stringFromDate:beginningOfWeek]; 
}



+(NSString * )getTwoTimeintervalStardate:(NSString *)stardate endDate:(NSString *)enddate andtype:(NSString *)type{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"yyyy年MM月dd日"];
    //然后创建日期对象
    NSDate *date1;
    
    if (stardate.length==0) {
        date1=[NSDate date];
    }else{
        date1 = [dateFormatter dateFromString:stardate];
    }
    NSDate *date = [dateFormatter dateFromString:enddate];
    //计算时间间隔（单位是秒）
    NSTimeInterval time = [date timeIntervalSinceDate:date1];
    
    //计算天数、时、分、秒
    
    int days = ((int)time)/(3600*24);
    
    
    
    return [NSString stringWithFormat:@"%d",days];

}



+(NSString * )getTwoTimeintervalStardate:(NSString *)stardate endDate:(NSString *)enddate{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    
    [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    
    //然后创建日期对象
    NSDate *date1;
   
    if (stardate.length==0) {
        date1=[NSDate date];
    }else{
        date1 = [dateFormatter dateFromString:stardate];
    }
    NSDate *date = [dateFormatter dateFromString:enddate];
    //计算时间间隔（单位是秒）
    NSTimeInterval time = [date timeIntervalSinceDate:date1];
    
    //计算天数、时、分、秒
    
    int days = ((int)time)/(3600*24);

    return [NSString stringWithFormat:@"%d",days];
    
    
    
    
}

+ (UIImage*)image:(UIImage*)image scaleToSize:(CGSize)size{
    UIGraphicsBeginImageContext(size);//size为CGSize类型，即你所需要的图片尺寸
    [image drawInRect:CGRectMake(0,0, size.width, size.height)];
    UIImage *scaledImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return scaledImage;
}


+ (BOOL)isPhoneNumberString:(NSString *)string
{
    if ([self isEmptyString:string]) {
        return NO;
    }
    if (string.length != 11)
    {
        return NO;
    }
    /**
     * 手机号码:
     * 13[0-9], 14[5,7], 15[0, 1, 2, 3, 5, 6, 7, 8, 9], 17[6, 7, 8], 18[0-9], 170[0-9]
     * 移动号段: 134,135,136,137,138,139,150,151,152,157,158,159,182,183,184,187,188,147,178,1705
     * 联通号段: 130,131,132,155,156,185,186,145,176,1709
     * 电信号段: 133,153,180,181,189,177,1700
     */
    NSString *MOBILE = @"^1(3[0-9]|4[57]|5[0-35-9]|8[0-9]|70)\\d{8}$";
    /**
     * 中国移动：China Mobile
     * 134,135,136,137,138,139,150,151,152,157,158,159,182,183,184,187,188,147,178,1705
     */
    NSString *CM = @"(^1(3[4-9]|4[7]|5[0-27-9]|7[8]|8[2-478])\\d{8}$)|(^1705\\d{7}$)";
    /**
     * 中国联通：China Unicom
     * 130,131,132,155,156,185,186,145,176,1709
     */
    NSString *CU = @"(^1(3[0-2]|4[5]|5[56]|7[6]|8[56])\\d{8}$)|(^1709\\d{7}$)";
    /**
     * 中国电信：China Telecom
     * 133,153,180,181,189,177,1700
     */
    NSString *CT = @"(^1(33|53|77|8[019])\\d{8}$)|(^1700\\d{7}$)";
    
    NSPredicate *regextestmobile = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", MOBILE];
    NSPredicate *regextestcm = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", CM];
    NSPredicate *regextestcu = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", CU];
    NSPredicate *regextestct = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", CT];
    
    if (([regextestmobile evaluateWithObject:string] == YES)
        || ([regextestcm evaluateWithObject:string] == YES)
        || ([regextestct evaluateWithObject:string] == YES)
        || ([regextestcu evaluateWithObject:string] == YES))
    {
        return YES;
    }
    else
    {
        return NO;
    }
}
+ (BOOL)isEmptyString:(NSString *)string
{
    if ([string isKindOfClass:[NSNull class]] ) {
        return YES;
    }
    if ([string isKindOfClass:[NSNumber class]]) {
        return NO;
    }
    if (!string || string.length == 0) {
        return YES;
    }
    if ([string isEqualToString:@" "]) {
        return YES;
    }
    
    if (string.length>1 && [[string substringToIndex:0] isEqualToString:@" "]) {
        return YES;
    }
    
    NSArray *array = [string componentsSeparatedByString:@" "];
    NSInteger lenghth = 0;
    for (NSString *substr in array) {
        lenghth+=substr.length;
        if (lenghth) {
            return NO;
        }
    }
    return !lenghth;
    return NO;
}
+(NSString *)timeChange3:(NSString *)timeStampString{
    
    // timeStampString 是服务器返回的13位时间
    
    // iOS 生成的时间戳是10位
    NSTimeInterval interval    =[timeStampString doubleValue] / 1000.0;
    NSDate *date               = [NSDate dateWithTimeIntervalSince1970:interval];
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    //     HH:mm:ss
    [formatter setDateFormat:@"MM-dd"];
    NSString *dateString       = [formatter stringFromDate: date];
    return dateString;
    
}

+(NSString *)timeChange:(NSString *)timeStampString andFormat:(NSString *)Format{
//    yyyy-MM-dd  HH:mm:ss
    // timeStampString 是服务器返回的13位时间
    
    // iOS 生成的时间戳是10位
    NSTimeInterval interval    =[timeStampString doubleValue] / 1000.0;
    NSDate *date               = [NSDate dateWithTimeIntervalSince1970:interval];
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
//     HH:mm:ss
    [formatter setDateFormat:Format];
    NSString *dateString       = [formatter stringFromDate: date];

    return dateString;
    
}

+(NSInteger)timeSwitchTimestamp:(NSString *)formatTime andFormatter:(NSString *)format{
    if (format ==nil) {
        format = @"MM月dd日";
    }
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    
    [formatter setDateFormat:format]; //(@"YYYY-MM-dd hh:mm:ss") ----------设置你想要的格式,hh与HH的区别:分别表示12小时制,24小时制
    
    NSTimeZone* timeZone = [NSTimeZone timeZoneWithName:@"Asia/Beijing"];
    
    [formatter setTimeZone:timeZone];
    
    NSString *time = [NSString stringWithFormat:@"%@",formatTime];
    
    NSDate* date = [formatter dateFromString:time]; //------------将字符串按formatter转成nsdate
     
    //时间转时间戳的方法:
    
    NSInteger timeSp = [[NSNumber numberWithDouble:[date timeIntervalSince1970]*1000] integerValue];
    return timeSp;
    
}

+(int)compareDate:(NSString*)date01 withDate:(NSString*)date02 andformat:(NSString *)format{
    int ci;
    NSDateFormatter *df = [[NSDateFormatter alloc] init];
    [df setDateFormat:format];
//    NSDate *dt1 = [[NSDate alloc] init];
//     *dt2 = [[NSDate alloc] init];
   NSDate *dt1 = [df dateFromString:date01];
  NSDate  *dt2 = [df dateFromString:date02];
    NSComparisonResult result = [dt1 compare:dt2];
    switch (result)
    {
            //date02比date01大
        case NSOrderedAscending: ci=1; break;
            //date02比date01小
        case NSOrderedDescending: ci=-1; break;
            //date02=date01
        case NSOrderedSame: ci=0; break;
        default: NSLog(@"erorr dates %@, %@", dt2, dt1); break;
    }
    return ci;
}


+(NSString * )getTwoTimeintervalStardate:(NSString *)stardate endDate:(NSString *)enddate andFormat:(NSString *)Format{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    
    [dateFormatter setDateFormat:Format];
    
    //然后创建日期对象
    NSDate *date1;
    if (stardate.length==0) {
        date1=[NSDate date];
    }else{
        date1 = [dateFormatter dateFromString:stardate];
    }
    NSDate *date = [dateFormatter dateFromString:enddate];
    //计算时间间隔（单位是秒）
    NSTimeInterval time = [date timeIntervalSinceDate:date1];
    
    //计算天数、时、分、秒
    
    int days = ((int)time)/(3600*24);
    
    
    
    return [NSString stringWithFormat:@"%d",days];
    
    
    
    
}
+(UIImage *)generateQrCode:(NSString *)CodeStr{
    //创建过滤器
        CIFilter *filter = [CIFilter filterWithName:@"CIQRCodeGenerator"];

        //过滤器恢复默认
         [filter setDefaults];
    
        //给过滤器添加数据
         NSString *string = CodeStr;
    
       //将NSString格式转化成NSData格式
        NSData *data = [string dataUsingEncoding:NSUTF8StringEncoding allowLossyConversion:YES];
    
        [filter setValue:data forKeyPath:@"inputMessage"];

        //获取二维码过滤器生成的二维码
         CIImage *image = [filter outputImage];
       CGRect extent = CGRectIntegral(image.extent);
       CGFloat scale = MIN(140/CGRectGetWidth(extent), 140/CGRectGetHeight(extent));
        size_t width = CGRectGetWidth(extent) * scale;
         size_t height = CGRectGetHeight(extent) * scale;
         CGColorSpaceRef cs = CGColorSpaceCreateDeviceGray();
         CGContextRef bitmapRef = CGBitmapContextCreate(nil, width, height, 8, 0, cs, (CGBitmapInfo)kCGImageAlphaNone);
         CIContext *context = [CIContext contextWithOptions:nil];
         CGImageRef bitmapImage = [context createCGImage:image fromRect:extent];
         CGContextSetInterpolationQuality(bitmapRef, kCGInterpolationNone);
         CGContextScaleCTM(bitmapRef, scale, scale);
         CGContextDrawImage(bitmapRef, extent, bitmapImage);
    
         // 2.保存bitmap到图片
         CGImageRef scaledImage = CGBitmapContextCreateImage(bitmapRef);
         CGContextRelease(bitmapRef);
         CGImageRelease(bitmapImage);
         return [UIImage imageWithCGImage:scaledImage];
    
    
    
    
    
}


+(NSString *)dateChangeString:(NSString *)time FristFormatter:(NSString *)frist endFormatter:(NSString *)end{

    NSTimeZone *timeZone=[NSTimeZone timeZoneWithAbbreviation:@"GMT"];
    
    NSDateFormatter *fmt=[[NSDateFormatter alloc]init];
    fmt.dateFormat = frist;
    fmt.timeZone = timeZone;
    NSDateFormatter *dstFmt=[[NSDateFormatter alloc]init];
    dstFmt.dateFormat = end;
    dstFmt.timeZone = timeZone;
//    @"yyyy-MM-dd"
    NSDate *srcDate=[fmt dateFromString:time];
    return [dstFmt stringFromDate:srcDate];
    
}
+(NSString *)currTimeNextNumDays:(NSString *)day andFormat:(NSString *)format{
    NSDate *nowDate = [NSDate date];
    NSDate* theDate;
    NSTimeInterval oneDay = 24*60*60; //1天的长度 (秒)
    //返回以当前NSDate对象为基准,偏移 多少 秒 后得到的新NSDate对象。
//    NSTimeZone *timeZone=[NSTimeZone timeZoneWithAbbreviation:@"GMT"];
    
    NSDateFormatter *fmt=[[NSDateFormatter alloc]init];
    fmt.dateFormat = format;
//    fmt.timeZone = timeZone;
    theDate = [nowDate dateByAddingTimeInterval: +oneDay*[day intValue]]; //后几天
    //theDate = [nowDate dateByAddingTimeInterval: -oneDay*dis]; //前几天
      NSString *dateString       = [fmt stringFromDate: theDate];
    
    return dateString;
}


//获取当前时间的毫秒数,转换为星期几
+ (NSString*)getCurrentWeekDay{
    NSTimeInterval data = [[NSDate date] timeIntervalSince1970];
    NSArray *weekday = [NSArray arrayWithObjects: [NSNull null], @"周日", @"周一", @"周二", @"周三", @"周四", @"周五", @"周六", nil];
    NSDate *newDate = [NSDate dateWithTimeIntervalSince1970:data];
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *components = [calendar components:NSCalendarUnitWeekday fromDate:newDate];
    NSString *weekStr = [weekday objectAtIndex:components.weekday];
    return weekStr;
}

+(NSString *)weekDayNextNumDays:(NSInteger )day{
    NSDate *nowDate = [NSDate date];
    NSDate* theDate;
    NSTimeInterval oneDay = 24*60*60; //1天的长度 (秒)
    theDate = [nowDate dateByAddingTimeInterval: +oneDay*day ]; //后几天
    NSTimeInterval data = [theDate timeIntervalSince1970];
    NSArray *weekday = [NSArray arrayWithObjects: [NSNull null], @"周日", @"周一", @"周二", @"周三", @"周四", @"周五", @"周六", nil];
    NSDate *newDate = [NSDate dateWithTimeIntervalSince1970:data];
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *components = [calendar components:NSCalendarUnitWeekday fromDate:newDate];
    NSString *weekStr = [weekday objectAtIndex:components.weekday];
    return weekStr;
    
}
@end
